
_SCL_HIGH:

;i2c_software.c,4 :: 		void SCL_HIGH(){
;i2c_software.c,5 :: 		TRISC3_bit = 1;
	BSF        TRISC3_bit+0, BitPos(TRISC3_bit+0)
;i2c_software.c,6 :: 		}
L_end_SCL_HIGH:
	RETURN
; end of _SCL_HIGH

_SDA_HIGH:

;i2c_software.c,7 :: 		void SDA_HIGH(){
;i2c_software.c,8 :: 		TRISC4_bit =1;
	BSF        TRISC4_bit+0, BitPos(TRISC4_bit+0)
;i2c_software.c,9 :: 		}
L_end_SDA_HIGH:
	RETURN
; end of _SDA_HIGH

_SDA_LOW:

;i2c_software.c,10 :: 		void SDA_LOW() {
;i2c_software.c,11 :: 		TRISC4_bit= 0;
	BCF        TRISC4_bit+0, BitPos(TRISC4_bit+0)
;i2c_software.c,12 :: 		RC4_bit=0;
	BCF        RC4_bit+0, BitPos(RC4_bit+0)
;i2c_software.c,13 :: 		}
L_end_SDA_LOW:
	RETURN
; end of _SDA_LOW

_SCL_LOW:

;i2c_software.c,14 :: 		void SCL_LOW() {
;i2c_software.c,15 :: 		TRISC3_bit= 0;
	BCF        TRISC3_bit+0, BitPos(TRISC3_bit+0)
;i2c_software.c,16 :: 		RC3_bit=0;
	BCF        RC3_bit+0, BitPos(RC3_bit+0)
;i2c_software.c,17 :: 		}
L_end_SCL_LOW:
	RETURN
; end of _SCL_LOW

_i2c_Start:

;i2c_software.c,19 :: 		void i2c_Start(void) {
;i2c_software.c,20 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
;i2c_software.c,21 :: 		SCL_HIGH();
	CALL       _SCL_HIGH+0
;i2c_software.c,22 :: 		delay_us(10);      // bring SDA low while SCL is high
	MOVLW      6
	MOVWF      R13+0
L_i2c_Start0:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Start0
	NOP
;i2c_software.c,23 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
;i2c_software.c,24 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,25 :: 		}
L_end_i2c_Start:
	RETURN
; end of _i2c_Start

_i2c_Stop:

;i2c_software.c,27 :: 		void i2c_Stop(void) {
;i2c_software.c,28 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
;i2c_software.c,29 :: 		SCL_HIGH();      // bring SDA high while SCL is high
	CALL       _SCL_HIGH+0
;i2c_software.c,30 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Stop1:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Stop1
	NOP
;i2c_software.c,31 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
;i2c_software.c,32 :: 		}
L_end_i2c_Stop:
	RETURN
; end of _i2c_Stop

_i2c_Write:

;i2c_software.c,34 :: 		void i2c_Write(unsigned char data1) {
;i2c_software.c,37 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,39 :: 		for (bit_temp = 0; bit_temp < 8; bit_temp++) {
	CLRF       i2c_Write_bit_temp_L0+0
L_i2c_Write2:
	MOVLW      8
	SUBWF      i2c_Write_bit_temp_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_i2c_Write3
;i2c_software.c,41 :: 		if (data1 & 0x80)
	BTFSS      FARG_i2c_Write_data1+0, 7
	GOTO       L_i2c_Write5
;i2c_software.c,42 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
	GOTO       L_i2c_Write6
L_i2c_Write5:
;i2c_software.c,44 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
L_i2c_Write6:
;i2c_software.c,46 :: 		SCL_HIGH();
	CALL       _SCL_HIGH+0
;i2c_software.c,47 :: 		data1 <<= 1;
	RLF        FARG_i2c_Write_data1+0, 1
	BCF        FARG_i2c_Write_data1+0, 0
;i2c_software.c,48 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Write7:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Write7
	NOP
;i2c_software.c,49 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,39 :: 		for (bit_temp = 0; bit_temp < 8; bit_temp++) {
	INCF       i2c_Write_bit_temp_L0+0, 1
;i2c_software.c,50 :: 		}
	GOTO       L_i2c_Write2
L_i2c_Write3:
;i2c_software.c,52 :: 		SCL_HIGH();
	CALL       _SCL_HIGH+0
;i2c_software.c,53 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
;i2c_software.c,54 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Write8:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Write8
	NOP
;i2c_software.c,55 :: 		bit_temp = portc.b4;//RC4_bit; // possible ACK bit
	MOVLW      0
	BTFSC      PORTC+0, 4
	MOVLW      1
	MOVWF      i2c_Write_bit_temp_L0+0
;i2c_software.c,57 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,58 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
;i2c_software.c,61 :: 		}
L_end_i2c_Write:
	RETURN
; end of _i2c_Write

_i2c_Read:

;i2c_software.c,63 :: 		unsigned char i2c_Read(char NACK) {
;i2c_software.c,67 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
;i2c_software.c,69 :: 		for (bit_temp = 0; bit_temp < 8; bit_temp++) {    // msbit first
	CLRF       i2c_Read_bit_temp_L0+0
L_i2c_Read9:
	MOVLW      8
	SUBWF      i2c_Read_bit_temp_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_i2c_Read10
;i2c_software.c,70 :: 		data1 <<= 1;
	RLF        i2c_Read_data1_L0+0, 1
	BCF        i2c_Read_data1_L0+0, 0
;i2c_software.c,71 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Read12:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Read12
	NOP
;i2c_software.c,72 :: 		SCL_HIGH();
	CALL       _SCL_HIGH+0
;i2c_software.c,74 :: 		if (portc.b4)
	BTFSS      PORTC+0, 4
	GOTO       L_i2c_Read13
;i2c_software.c,75 :: 		data1 |= 1;
	BSF        i2c_Read_data1_L0+0, 0
L_i2c_Read13:
;i2c_software.c,76 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Read14:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Read14
	NOP
;i2c_software.c,77 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,69 :: 		for (bit_temp = 0; bit_temp < 8; bit_temp++) {    // msbit first
	INCF       i2c_Read_bit_temp_L0+0, 1
;i2c_software.c,78 :: 		}
	GOTO       L_i2c_Read9
L_i2c_Read10:
;i2c_software.c,80 :: 		if (NACK == 1)
	MOVF       FARG_i2c_Read_NACK+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_i2c_Read15
;i2c_software.c,81 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
	GOTO       L_i2c_Read16
L_i2c_Read15:
;i2c_software.c,83 :: 		SDA_HIGH();
	CALL       _SDA_HIGH+0
L_i2c_Read16:
;i2c_software.c,85 :: 		SCL_HIGH();
	CALL       _SCL_HIGH+0
;i2c_software.c,86 :: 		delay_us(10);
	MOVLW      6
	MOVWF      R13+0
L_i2c_Read17:
	DECFSZ     R13+0, 1
	GOTO       L_i2c_Read17
	NOP
;i2c_software.c,87 :: 		SCL_LOW();
	CALL       _SCL_LOW+0
;i2c_software.c,88 :: 		SDA_LOW();
	CALL       _SDA_LOW+0
;i2c_software.c,90 :: 		return data1;
	MOVF       i2c_Read_data1_L0+0, 0
	MOVWF      R0+0
;i2c_software.c,91 :: 		}
L_end_i2c_Read:
	RETURN
; end of _i2c_Read
