#include "i2c_software.h"
#include "built_in.h"

void SCL_HIGH(){
TRISC3_bit = 1;
}
void SDA_HIGH(){
TRISC4_bit =1;
}
void SDA_LOW() {
TRISC4_bit= 0;
RC4_bit=0;
}
void SCL_LOW() {
TRISC3_bit= 0;
RC3_bit=0;
}

void i2c_Start(void) {
    SDA_HIGH();
    SCL_HIGH();
    delay_us(10);      // bring SDA low while SCL is high
    SDA_LOW();
    SCL_LOW();
}

void i2c_Stop(void) {
    SDA_LOW();
    SCL_HIGH();      // bring SDA high while SCL is high
    delay_us(10);
    SDA_HIGH();
}

void i2c_Write(unsigned char data1) {
    char bit_temp;

    SCL_LOW();

    for (bit_temp = 0; bit_temp < 8; bit_temp++) {

        if (data1 & 0x80)
            SDA_HIGH();
        else
            SDA_LOW();

        SCL_HIGH();
        data1 <<= 1;
        delay_us(10);
        SCL_LOW();
    }

    SCL_HIGH();
    SDA_HIGH();
    delay_us(10);
    bit_temp = portc.b4;//RC4_bit; // possible ACK bit

    SCL_LOW();
    SDA_LOW();

//    return bit_temp;
}

unsigned char i2c_Read(char NACK) {
    char bit_temp;
    unsigned char data1;

    SDA_HIGH();

    for (bit_temp = 0; bit_temp < 8; bit_temp++) {    // msbit first
        data1 <<= 1;
        delay_us(10);
        SCL_HIGH();
                        // bring data high and clock
        if (portc.b4)
            data1 |= 1;
        delay_us(10);
        SCL_LOW();
    }

    if (NACK == 1)
        SDA_LOW();
    else
        SDA_HIGH();

    SCL_HIGH();
    delay_us(10);
    SCL_LOW();
    SDA_LOW();

    return data1;
}